-- CONTROL
script.on_event(defines.events.on_player_joined_game, function(e)
	local player = game.players[e.player_index]
	local character = player.cutscene_character;

	-- If cutscene character is null, try regular character
	if character == nil then
		character = player.character;
	end

	-- A check for Sandbox mode.
	if character == nil then
		player.print("Robot Quick Start - No character found.")
		return
	end
	
	local inventory = character.get_main_inventory();
	local armorInventory = character.get_inventory(defines.inventory.character_armor);

	-- Adding Construction Robots.
	inventory.insert{name="construction-robot", count = settings.startup["starting-robot-count"].value}

	-- Adding the Power Armor MK2 to the player.
	armorInventory.insert{name = "power-armor-mk2", count = 1}
	character.grid.put{name = "fusion-reactor-equipment", position = {0, 0}}
	character.grid.put{name = "fusion-reactor-equipment", position = {0, 4}}

	-- Inserting the other equipment into the armor.
	local list = {}
	table.insert(list, character.grid.put{name = "exoskeleton-equipment", position = {4, 0}})
	table.insert(list, character.grid.put{name = "exoskeleton-equipment", position = {6, 0}})
	table.insert(list, character.grid.put{name = "exoskeleton-equipment", position = {8, 0}})
	table.insert(list, character.grid.put{name = "exoskeleton-equipment", position = {4, 4}})
	table.insert(list, character.grid.put{name = "exoskeleton-equipment", position = {6, 4}})
	table.insert(list, character.grid.put{name = "battery-mk2-equipment", position = {8, 4}})
	table.insert(list, character.grid.put{name = "battery-mk2-equipment", position = {9, 4}})
	table.insert(list, character.grid.put{name = "personal-laser-defense-equipment", position = {8, 6}})
	table.insert(list, character.grid.put{name = "night-vision-equipment", position = {0, 8}})
	table.insert(list, character.grid.put{name = "personal-roboport-mk2-equipment", position = {2, 8}})
	table.insert(list, character.grid.put{name = "personal-roboport-mk2-equipment", position = {4, 8}})
	table.insert(list, character.grid.put{name = "personal-roboport-mk2-equipment", position = {6, 8}})
	table.insert(list, character.grid.put{name = "personal-roboport-mk2-equipment", position = {8, 8}})
	
	-- Filling up the equipments energy.
	for i, v in ipairs(list) do
		v.energy = v.max_energy
	end
end
)